<?php
$scriptEmbedQsa = '?ver=' . $AudiencePlayerWordpressPlugin::fetchPluginCacheString();
$audiencePlayerBearerToken = $AudiencePlayerWordpressPlugin->fetchUserBearerToken();
$isWordpressUserLoggedIn = \is_user_logged_in();
$isAudiencePlayerUserLoggedIn = $audiencePlayerBearerToken || false;
?>
<script type="module">

    // Expand config with necessary credentials
    window.AudiencePlayerLib = {};

    // Api properties
    window.AudiencePlayerLib.apiBaseUrl = '<?php echo $AudiencePlayerWordpressPlugin->fetchApiBaseUrl(); ?>';
    window.AudiencePlayerLib.siteBaseUrl = '<?php echo \site_url(); ?>';
    window.AudiencePlayerLib.chromecastReceiverAppId = '<?php echo $AudiencePlayerWordpressPlugin->fetchChromecastReceiverAppId(); ?>';
    window.AudiencePlayerLib.projectId = '<?php echo $AudiencePlayerWordpressPlugin->fetchProjectId(); ?>';
    window.AudiencePlayerLib.paymentProviderId = '<?php echo $AudiencePlayerWordpressPlugin->fetchPaymentProviderId(); ?>';
    window.AudiencePlayerLib.userBearerToken = '<?php echo $audiencePlayerBearerToken; ?>';
    window.AudiencePlayerLib.userBearerTokenTtl = <?php echo ($AudiencePlayerWordpressPlugin->fetchUserBearerTokenTtl() - 60) * 1000; ?>;
    window.AudiencePlayerLib.currentUrl = '<?php echo $AudiencePlayerWordpressPlugin->fetchCurrentUrl(); ?>';
    window.AudiencePlayerLib.loginUrlWithRedirect = '<?php echo $AudiencePlayerWordpressPlugin->fetchLoginUrl(true); ?>';
    window.AudiencePlayerLib.isLoggedIn = <?php echo $isWordpressUserLoggedIn ? 'true' : 'false'; ?>;
    window.AudiencePlayerLib.isSynchronised = <?php echo $isAudiencePlayerUserLoggedIn ? 'true' : 'false'; ?>;
    window.AudiencePlayerLib.tokenParameter = window.AudiencePlayerLib.userBearerToken ? {token: window.AudiencePlayerLib.userBearerToken} : {};

    // Translations
    window.AudiencePlayerLib.translations = {
        <?php
        $translations = $AudiencePlayerWordpressPlugin->fetchTranslations(null, '', [], false);

        foreach ($translations as $key => $value) {
            echo $key . ': \'' . $AudiencePlayerWordpressPlugin->helper->sanitiseJsString($value) . '\',';
        }
        ?>
    };

    // Import external dependencies
    import EmbedPlayer from '<?php echo $AudiencePlayerWordpressPlugin->fetchEmbedPlayerLibraryBaseUrl(); ?>/embed-player.js<?php echo $scriptEmbedQsa; ?>';
    import ChromecastControls from '<?php echo $AudiencePlayerWordpressPlugin->fetchEmbedPlayerLibraryBaseUrl(); ?>/chromecast-controls.js<?php echo $scriptEmbedQsa; ?>';

    // Hydrate EmbedPlayer
    window.AudiencePlayerLib.EmbedPlayer = new EmbedPlayer();

    if (window.AudiencePlayerLib.chromecastReceiverAppId) {

        window.AudiencePlayerLib.EmbedPlayer.setupChromecast('#cast-wrapper', window.AudiencePlayerLib.chromecastReceiverAppId)
            .then(() => {
                const controls = new ChromecastControls(window.AudiencePlayerLib.EmbedPlayer.getCastPlayer(), window.AudiencePlayerLib.EmbedPlayer.getCastPlayerController());
                document.getElementById('cast-wrapper').style.display = 'unset';
                document.querySelector('.chromecast-button').style.display = 'flex';
            });
    }
</script>
<script>
    <?php

    /*
     * Create global error message accessible to unsupported browsers
     */
    echo 'window.AudiencePlayerBrowserNotSupportedError = \'' .
        $AudiencePlayerWordpressPlugin->helper()
            ->sanitiseJsString($AudiencePlayerWordpressPlugin->fetchTranslations('dialogue_not_optimised_for_current_browser')) .
        '\';';

    /*
     * Handle redirect/afterPurchase action after user returns from external payment provider url
     * N.B. the purchase modal action handlers based on "purchase_product_id" and "purchase_subscription_id" are located
     * in the respective shortcode templates
     */
    if ($orderId = intval($_REQUEST['user_payment_account_order_id'] ?? 0)) {

        if ($AudiencePlayerWordpressPlugin->isOrderValidated($orderId)) {

            if ($_REQUEST['after_purchase_action'] ?? null) {
                echo $AudiencePlayerWordpressPlugin->executeJsShortCodeAction($_REQUEST['after_purchase_action']);
            } else {
                echo 'jQuery(function ($) {window.AudiencePlayerCore.openModalAlert(null, window.AudiencePlayerCore.CONFIG.translations.dialogue_payment_successfully_completed);});';
            }

        } else {
            echo 'jQuery(function ($) {window.AudiencePlayerCore.openModalAlert(null, window.AudiencePlayerCore.CONFIG.translations.dialogue_payment_not_validated);});';
        }
    }
    ?>
</script>
