<?php

$content = $content ?? '';

if ($AudiencePlayerWordpressPlugin->isAuthenticated() && \is_user_logged_in()) {

    $result = $AudiencePlayerWordpressPlugin->api()->query
        ->UserDetails()
        ->properties(['
            id
            phone
            notifiable
            is_phone_verified
            user_subscriptions {
                id
                status
                subscription_id
                suspendable_at
                expires_at
                invoiced_at
                is_valid
                is_suspendable
                is_account_method_changeable
                subscription {id title description_short}
                account {id method method_details}
            }
            orders {id description currency_symbol amount status status_name installed_at}
            ', ''])
        ->execute();

    if ($result->isSuccessful() && ($user = ($result->getData(true)))) {

        // assemble authentication and authorisation actions
        $actionAuthentication = $AudiencePlayerWordpressPlugin->parseJsShortCodeAction($args['authentication_action'] ?: $AudiencePlayerWordpressPlugin->fetchLoginUrl(true));

        $validUserSubscription = null;
        $expiresAt = '-';
        $invoicedAt = '-';
        $isSuspendable = false;
        $isSuspended = false;
        $isNotifiable = $user->notifiable === 'none' ? false : true;

        foreach ($user->user_subscriptions as $userSubscription) {
            if ($userSubscription->is_valid) {
                $validUserSubscription = $userSubscription;
                $expiresAt = $AudiencePlayerWordpressPlugin->parseDateTimeValue(($validUserSubscription->suspendable_at ?? null) ?: ($validUserSubscription->expires_at ?? null));
                $invoicedAt = $AudiencePlayerWordpressPlugin->parseDateTimeValue(($validUserSubscription->invoiced_at ?? null) ?: ($validUserSubscription->invoiced_at ?? null));
                $isSuspendable = $validUserSubscription->is_suspendable ?? true;
                $isSuspended = $validUserSubscription->status === 'suspended';
                break;
            }
        }

        $content .= '<div class="audienceplayer-user-account ' . ($args['class'] ?? '') . '">';
        $content .= '<div class="wrapper">';

        /* ### subscription info ##################################################################################### */
        if ($args['show_subscription_info']) {

            $title = (isset($validUserSubscription, $validUserSubscription->subscription)) ?
                ($validUserSubscription->subscription->title ?? '-') : '-';

            $content .=
                '<div class="subscription-info section">' .
                '<div class="wrapper">' .

                '<div class="description subsection">' .
                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_subscription') . '</div>' .
                '<div class="value">' . $title . '</div>' .
                '</div>' .

                '<div class="expires-at subsection">' .
                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_valid_until') . '</div>' .
                '<div class="value">' . $expiresAt . '</div>' .
                '</div>' .

                '<div class="invoiced-at subsection">' .
                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_date_next_invoice') . '</div>' .
                '<div class="value ' . ($isSuspended ? 'disabled' : '') . '">' . $invoicedAt . '</div>' .
                '</div>' .

                '</div>' .
                '</div>';
        }

        /* ### voucher redeem ######################################################################################## */
        if ($args['show_voucher_redeem']) {
            $content .=
                '<div class="voucher-redeem section">' .
                '<div class="wrapper">' .

                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_redeem_voucher_code') . '</div>' .

                '<div class="voucher">' .
                '<div class="input"><input class="voucher-validate-input" id="audienceplayer-user-account-validate-voucher-input" /></div>' .
                '<div class="button"><button class="voucher-validate-button" id="audienceplayer-user-account-validate-voucher-button">' . $AudiencePlayerWordpressPlugin->fetchTranslations('button_redeem_voucher') . '</button></div>' .
                '</div>' .

                '</div>' .
                '</div>';

            $content .= '<script>jQuery(function($){' .
                '$("#audienceplayer-user-account-validate-voucher-button").click(function(){' .
                'window.AudiencePlayerCore.redeemUserAccountVoucherCode(' .
                'this,' .
                '$("#audienceplayer-user-account-validate-voucher-input").val(),' .
                $AudiencePlayerWordpressPlugin->fetchPaymentProviderId() . ',' .
                ($validUserSubscription ? $validUserSubscription->subscription->id : 0) . ',' .
                ($validUserSubscription ? $validUserSubscription->id : 0) .
                ');' .
                '});' .
                '});</script>';
        }

        /* ### subscription suspend ################################################################################## */
        if ($args['show_subscription_suspend'] && $isSuspendable) {

            $content .=
                '<div class="subscription-suspend section">' .
                '<div class="wrapper">' .

                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_renew_subscription') . '</div>' .
                '<div class="description">' . $AudiencePlayerWordpressPlugin->fetchTranslations('dialogue_subscription_renew') . '</div>' .
                '<div class="value">' .
                '<div class="audienceplayer-toggle-input"><div class="toggle-input">' .
                '<input id="audienceplayer-user-subscription-is-suspend-' . $validUserSubscription->id . '" name="audienceplayer_user_subscription_is_suspend" type="checkbox" ' . ($isSuspended ? '' : 'checked') . ' />' .
                '<label for="audienceplayer-user-subscription-is-suspend-' . $validUserSubscription->id . '" ' .
                'data-off="' . $AudiencePlayerWordpressPlugin->fetchTranslations('form_toggle_recurring_subscription_off') . '" ' .
                'data-on="' . $AudiencePlayerWordpressPlugin->fetchTranslations('form_toggle_recurring_subscription_on') . '" ' .
                '></label>' .
                '</div></div>' .
                '</div>' .

                '</div>' .
                '</div>';

            $content .= '<script>jQuery(function($){' .
                '$("#audienceplayer-user-subscription-is-suspend-' . $validUserSubscription->id . '").click(function(){' .
                'window.AudiencePlayerCore.toggleUserSubscriptionStatus(this,' . $validUserSubscription->id . ',this.checked,' . $actionAuthentication . ');' .
                '});' .
                '});</script>';
        }

        /* ### notifiable ############################################################################################ */
        if ($args['show_notifiable']) {

            $content .=
                '<div class="subscription-notifiable section">' .
                '<div class="wrapper">' .

                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_sms_notifications') . '</div>' .
                '<div class="description">' . $AudiencePlayerWordpressPlugin->fetchTranslations('dialogue_activate_sms_notifications') . '</div>' .
                '<div class="value">' .
                '<div class="audienceplayer-toggle-input"><div class="toggle-input">' .
                '<input id="audienceplayer-user-is-notifiable-' . $user->id . '" name="audienceplayer_user_is_notifiable" type="checkbox" ' . ($isNotifiable ? 'checked' : '') . ' />' .
                '<label for="audienceplayer-user-is-notifiable-' . $user->id . '" ' .
                'data-off="' . $AudiencePlayerWordpressPlugin->fetchTranslations('form_toggle_off') . '" ' .
                'data-on="' . $AudiencePlayerWordpressPlugin->fetchTranslations('form_toggle_on') . '" ' .
                '></label>' .
                '<input id="audienceplayer-user-phone-' . $user->id . '" name="audienceplayer_user_phone" type="hidden" value="' . $user->phone . '" />' .
                '</div></div>' .
                '</div>' .

                '</div>' .
                '</div>';

            $content .= '<script>jQuery(function($){' .
                '$("#audienceplayer-user-is-notifiable-' . $user->id . '").click(function(){' .
                'window.AudiencePlayerCore.toggleUserNotifiableStatus(this, this.checked, $("#audienceplayer-user-phone-' . $user->id . '"), ' . $actionAuthentication . ');' .
                '});' .
                '});</script>';
        }

        /* ### payment method ######################################################################################## */
        if ($args['show_payment_method'] && ($validUserSubscription->is_account_method_changeable ?? null)) {

            if ($isAccount = boolval($validUserSubscription->account->method)) {

                $accountDetails =
                    $validUserSubscription->account->method . '<br />' .
                    $validUserSubscription->account->method_details . '<br />' .
                    '<div><a href="javascript:void(0);" onclick="window.AudiencePlayerCore.openModalPurchase(this, \'payment_method\',' .
                    $validUserSubscription->account->id . ',' .
                    'window.AudiencePlayerCore.CONFIG.translations.dialogue_payment_method_change_cost_explanation,' .
                    'false' .
                    ');">' . $AudiencePlayerWordpressPlugin->fetchTranslations('dialogue_payment_method_change') . '</a></div>';

            } else {

                $accountDetails =
                    $AudiencePlayerWordpressPlugin->fetchTranslations('dialogue_payment_method_not_configured') .
                    '<div><a href="javascript:void(0);" onclick="window.AudiencePlayerCore.openModalPurchase(this, \'payment_method\',' .
                    $validUserSubscription->account->id . ',' .
                    'window.AudiencePlayerCore.CONFIG.translations.dialogue_payment_method_change_cost_explanation,' .
                    'false' .
                    ');">' . $AudiencePlayerWordpressPlugin->fetchTranslations('dialogue_payment_method_add') . '</a></div>';
            }

            $content .=
                '<div class="payment-method section">' .
                '<div class="wrapper">' .
                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_payment_method') . '</div>' .
                '<div class="description">' . $accountDetails . '</div>' .
                '</div>' .
                '</div>';
        }

        /* ### payment orders ######################################################################################## */
        if ($args['show_payment_orders'] && ($user->orders ?? null)) {

            $content .=
                '<div class="payment-orders section">' .
                '<div class="wrapper">' .
                '<div class="label">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_orders') . '</div>';

            $content .=
                '<table class="table" cellpadding="0" cellspacing="0" border="0">' .
                '<tr class="header">' .
                '<td>' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_order_table_product') . '</td>' .
                '<td>' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_order_table_amount') . '</td>' .
                '<td>' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_order_table_date') . '</td>' .
                '<td>' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_order_table_status') . '</td>' .
                '</tr>';

            foreach ($user->orders as $order) {

                $content .=
                    '<tr class="body">' .
                    '<td class="description">' . $order->description . '</td>' .
                    '<td class="amount">' . $order->currency_symbol . ' ' . $order->amount . '</td>' .
                    '<td class="date">' . $AudiencePlayerWordpressPlugin->parseDateTimeValue($order->installed_at) . '</td>' .
                    '<td class="status">' . $AudiencePlayerWordpressPlugin->fetchTranslations('label_order_table_status_' . $order->status, $order->status_name ?: $order->status) . '</td>' .
                    '</tr>';
            }

            $content .= '</table>';
            $content .= '</div>';
            $content .= '</div>';

        }

        /* ############################################################################################################### */

        $content .= '</div>';
        $content .= '</div>';

    } elseif (($code = $result->getFirstErrorCode()) > 500) {
        $msg = 'query error occurred, code: ' . $code;
        $AudiencePlayerWordpressPlugin->pushPublicDebugStack('[audienceplayer_shortcode_user_account]', $msg);
        \trigger_error('Warning in shortcode [audienceplayer_shortcode_user_account]: ' . $msg, E_USER_WARNING);
    }

} else {
    $msg = 'user is not authenticated, contents cannot be displayed';
    $AudiencePlayerWordpressPlugin->pushPublicDebugStack('[audienceplayer_shortcode_user_account]', $msg);
    \trigger_error('Warning in shortcode [audienceplayer_shortcode_user_account]: ' . $msg, E_USER_WARNING);
}

$AudiencePlayerWordpressPlugin->pushPublicDebugStack('[audienceplayer_shortcode_user_account]', $AudiencePlayerWordpressPlugin->api()->fetchLastOperationQuery(true), $AudiencePlayerWordpressPlugin->api()->fetchLastOperationResult());
